// plugin_tele_antiflood.sma
// Author: [PCE]teledyne
// Date December 31, 2001
// Last Modified December 31, 2001
//
// Fuctionality of this plugin:
// It is a flooding filter so people don't say too much too fast.
// It determines that a user is flooding the server if they say
// 5 things in less than 2 seconds (default values).
//
// I basically edited sank's script and I changed it to make the
// flooder execute disconnect.  Wanted to see how much better (or
// worse) it would do.

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>


// The plugin will drop a player if they say more than MAX_LIMIT things
// in less than MAX_SECS seconds.  The plugin will simply warn a
// player if they say more than WARN_LIMIT things in less than MAX_SECS
// seconds.
#define MAX_LIMIT 5
// default MAX_LIMIT 5
#define WARN_LIMIT 1
// default WARN_LIMIT 4
#define MAX_SECS 1
// default MAX_SECS 2



/****************************************************************************/
/****************************************************************************/
/************** DO NOT MODIFY CONTENTS BELOW THIS LINE !!! ******************/
/************** DO NOT MODIFY CONTENTS BELOW THIS LINE !!! ******************/
/************** DO NOT MODIFY CONTENTS BELOW THIS LINE !!! ******************/
/****************************************************************************/
/****************************************************************************/


new STRING_VERSION[MAX_DATA_LENGTH] = "2.50.11";

// Keep track of when the last thing was said
new LastTime[MAX_PLAYERS+1];
// Keep track of the number of things said for each second in the window
new NumSaid[MAX_PLAYERS+1][MAX_SECS];
// Remember if we dropped the person
new WasDropped[MAX_PLAYERS+1] = {0,...};


public plugin_init() 
{
	plugin_registerinfo("teledyne plugin 1", "teledyne plugin 1", STRING_VERSION);
	plugin_registercmd("say", "HandleSay", ACCESS_ALL);
	plugin_registercmd("team_say", "HandleSay", ACCESS_ALL);

	return PLUGIN_CONTINUE;
}

public plugin_connect(HLUserName, HLIP, UserIndex) 
{
	// Reset the user's data when they connect
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS)
	{
		new i;
		for (i = 0; i < MAX_SECS; i++)
			NumSaid[UserIndex][i] = 0;
		LastTime[UserIndex] = 0;
		WasDropped[UserIndex] = false;
	}
	return PLUGIN_CONTINUE;
}


/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/


// Status codes
#define FLOOD_WARN 1
#define FLOOD_DROP 2
///////////////////////////////////////////////////////////////////////////////
// Returns 0 if the user is allowed to say things
// Returns FLOOD_WARN if the user needs to be warned
// Returns FLOOD_DROP if the user needs to be disconnected
///////////////////////////////////////////////////////////////////////////////
IsFlooding(User[], UserIndex)
{
	if(check_immunity(User) == 0)
	{
		new i, j;
		new Total = 0;
		new CurTime = systemtime();
		new SecsAgo;

		// Special case if this is the first time the user has said
		// anything since they joined
		if (LastTime[UserIndex] == 0)
		{
			LastTime[UserIndex] = CurTime;
			return 0;
		}

		// Determine how many seconds ago the last thing was said
		SecsAgo = CurTime - LastTime[UserIndex];

		// Do some bookkeeping
		if (SecsAgo > MAX_SECS)
		{
			for (i = 0; i < MAX_SECS; i++)
				NumSaid[UserIndex][i] = 0;
		}
		else
		{
			for (j = 0; j < SecsAgo; j++)
			{
				for (i = 1; i < MAX_SECS; i++)
					NumSaid[UserIndex][i] = NumSaid[UserIndex][i-1];
				NumSaid[UserIndex][0] = 0;
			}
		}

		// Update User Data
		NumSaid[UserIndex][0] = NumSaid[UserIndex][0] + 1;
		LastTime[UserIndex] = CurTime;

		// Calculate the number of things the player has said in
		// the last MAX_SECS
		for (i = 0; i < MAX_SECS; i++)
			Total += NumSaid[UserIndex][i];

		// If they've said too much, then drop them.
		if (Total > MAX_LIMIT)
			return FLOOD_DROP;

		// Or, maybe warn them.
		else if (Total > WARN_LIMIT)
			return FLOOD_WARN;

		} // end if not immune

	return 0;
}


///////////////////////////////////////////////////////////////////////////////
// Everything a person says goes through here, and we determine if they are
// chatting too fast or not.
///////////////////////////////////////////////////////////////////////////////
public HandleSay(HLCommand, HLData, HLUserName, UserIndex) 
{
	new Status;
	new Text[MAX_TEXT_LENGTH];
	new Date[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData, Data, MAX_DATA_LENGTH);
	convert_string(HLUserName, User, MAX_NAME_LENGTH);

	// Check to see if the user is flooding the server or not
	Status = IsFlooding(User, UserIndex);

	if (Status == FLOOD_WARN)
	{
		messageex(User, "Stop flooding!", print_center);
		messageex(User, "Stop flooding!", print_console);

		return PLUGIN_HANDLED;
	}
	else if (Status == FLOOD_DROP)
	{
		if (WasDropped[UserIndex])
		{
			return PLUGIN_HANDLED;
		}
		WasDropped[UserIndex] = true;
		message(User, "You were warned, but did not stop flooding the server.");
		servertime(Date, MAX_NUMBER_LENGTH, "%m/%d/%y %H:%M");
		snprintf(Text, MAX_TEXT_LENGTH, "%s - %s was dropped saying %s.", Date, User, Data);
		writefile("FloodLog.txt", Text);
		log(Text);
		execclient(User,"disconnect");

		return PLUGIN_HANDLED;
	}

	return PLUGIN_CONTINUE;
}